searchNodes=[{"ref":"Ecto.Adapters.Neo4j.html","title":"Ecto.Adapters.Neo4j","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.html#autogenerate/1","title":"Ecto.Adapters.Neo4j.autogenerate/1","type":"function","doc":"Called to autogenerate a value for id/embed_id/binary_id. Returns the autogenerated value, or nil if it must be autogenerated inside the storage or raise if not supported. Callback implementation for Ecto.Adapter.Schema.autogenerate/1."},{"ref":"Ecto.Adapters.Neo4j.html#batch_query/4","title":"Ecto.Adapters.Neo4j.batch_query/4","type":"function","doc":"Execute given query in batch. There is two type of batches: :basic will use LIMIT to loop until every node is touched :with_skip will use SKIP and LIMIT until every node is touched In order to work, the query must contains: for :basic, LIMIT {limit} for :with_skip, SKIP {skip} LIMIT {limit} in any case: RETURN COUNT(my_nodes) AS nb_touched_nodes with my_nodes being the nodes you&#39;re working on The LIMIT is set by default to 10_000, but you can set your aown value via the option :chunk_size Example # :basic example iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; LIMIT ...&gt; {limit} ...&gt; DETACH DELETE n ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql) {:ok, []} # :with_skip example iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; ORDER BY ...&gt; n.nodeId ...&gt; SKIP ...&gt; {skip} ...&gt; LIMIT ...&gt; {limit} ...&gt; SET ...&gt; n.value = {new_value} ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql, %{new_value: 5}, :with_skip) {:ok, []} # :basic example with `chunk_size` option specifiedd iex&gt; cql = &quot; ...&gt; MATCH ...&gt; (n:Test) ...&gt; WITH ...&gt; n AS n ...&gt; LIMIT ...&gt; {limit} ...&gt; DETACH DELETE n ...&gt; RETURN ...&gt; COUNT(n) AS nb_touched_nodes ...&gt; &quot; iex&gt; Ecto.Adapters.Neo4j.batch_query(cql, %{}, :basic, chunk_size: 20_000) {:ok, []}"},{"ref":"Ecto.Adapters.Neo4j.html#batch_query!/4","title":"Ecto.Adapters.Neo4j.batch_query!/4","type":"function","doc":"Same as batch_query!/4 but raises in case of error."},{"ref":"Ecto.Adapters.Neo4j.html#checkout/3","title":"Ecto.Adapters.Neo4j.checkout/3","type":"function","doc":"Checks out a connection for the duration of the given function. In case the adapter provides a pool, this guarantees all of the code inside the given fun runs against the same connection, which might improve performance by for instance allowing multiple related calls to the datastore to share cache information: Repo.checkout(fn -&gt; for _ &lt;- 100 do Repo.insert!(%Post{}) end end) If the adapter does not provide a pool, just calling the passed function and returning its result are enough. If the adapter provides a pool, it is supposed to &quot;check out&quot; one of the pool connections for the duration of the function call. Which connection is checked out is not passed to the calling function, so it should be done using a stateful method like using the current process&#39; dictionary, process tracking, or some kind of other lookup method. Make sure that this stored connection is then used in the other callbacks implementations, such as Ecto.Adapter.Queryable and Ecto.Adapter.Schema. Callback implementation for Ecto.Adapter.checkout/3."},{"ref":"Ecto.Adapters.Neo4j.html#delete/4","title":"Ecto.Adapters.Neo4j.delete/4","type":"function","doc":"Deletes a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.delete/4."},{"ref":"Ecto.Adapters.Neo4j.html#dumpers/2","title":"Ecto.Adapters.Neo4j.dumpers/2","type":"function","doc":"Returns the dumpers for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of dumpers with the given type usually at the beginning. This allows developers to properly translate values coming from the Ecto into adapter ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def dumpers(:boolean, type), do: [type, &amp;bool_encode/1] def dumpers(_primitive, type), do: [type] defp bool_encode(false), do: {:ok, 0} defp bool_encode(true), do: {:ok, 1} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def dumpers(:binary_id, type), do: [type, Ecto.UUID] def dumpers(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.dumpers/2."},{"ref":"Ecto.Adapters.Neo4j.html#ensure_all_started/2","title":"Ecto.Adapters.Neo4j.ensure_all_started/2","type":"function","doc":"Ensure all applications necessary to run the adapter are started. Callback implementation for Ecto.Adapter.ensure_all_started/2."},{"ref":"Ecto.Adapters.Neo4j.html#execute/6","title":"Ecto.Adapters.Neo4j.execute/6","type":"function","doc":"See Ecto.Adapters.Neo4j.Behaviour.Queryable.execute/6."},{"ref":"Ecto.Adapters.Neo4j.html#execute_ddl/3","title":"Ecto.Adapters.Neo4j.execute_ddl/3","type":"function","doc":"See Ecto.Adapters.Neo4j.Storage.Migrator.execute_ddl/3."},{"ref":"Ecto.Adapters.Neo4j.html#in_transaction?/1","title":"Ecto.Adapters.Neo4j.in_transaction?/1","type":"function","doc":"Returns true if the given process is inside a transaction. Callback implementation for Ecto.Adapter.Transaction.in_transaction?/1."},{"ref":"Ecto.Adapters.Neo4j.html#init/1","title":"Ecto.Adapters.Neo4j.init/1","type":"function","doc":"Initializes the adapter supervision tree by returning the children and adapter metadata. Callback implementation for Ecto.Adapter.init/1."},{"ref":"Ecto.Adapters.Neo4j.html#insert/6","title":"Ecto.Adapters.Neo4j.insert/6","type":"function","doc":"Inserts a single new struct in the data store. Autogenerate The primary key will be automatically included in returning if the field has type :id or :binary_id and no value was set by the developer or none was autogenerated by the adapter. Callback implementation for Ecto.Adapter.Schema.insert/6."},{"ref":"Ecto.Adapters.Neo4j.html#insert_all/7","title":"Ecto.Adapters.Neo4j.insert_all/7","type":"function","doc":"Inserts multiple entries into the data store. In case an Ecto.Query given as any of the field values by the user, it will be sent to the adapter as a tuple with in the shape of {query, params}. Callback implementation for Ecto.Adapter.Schema.insert_all/7."},{"ref":"Ecto.Adapters.Neo4j.html#loaders/2","title":"Ecto.Adapters.Neo4j.loaders/2","type":"function","doc":"Returns the loaders for a given type. It receives the primitive type and the Ecto type (which may be primitive as well). It returns a list of loaders with the given type usually at the end. This allows developers to properly translate values coming from the adapters into Ecto ones. For example, if the database does not support booleans but instead returns 0 and 1 for them, you could add: def loaders(:boolean, type), do: [&amp;bool_decode/1, type] def loaders(_primitive, type), do: [type] defp bool_decode(0), do: {:ok, false} defp bool_decode(1), do: {:ok, true} All adapters are required to implement a clause for :binary_id types, since they are adapter specific. If your adapter does not provide binary ids, you may simply use Ecto.UUID: def loaders(:binary_id, type), do: [Ecto.UUID, type] def loaders(_primitive, type), do: [type] Callback implementation for Ecto.Adapter.loaders/2."},{"ref":"Ecto.Adapters.Neo4j.html#lock_for_migrations/4","title":"Ecto.Adapters.Neo4j.lock_for_migrations/4","type":"function","doc":"See Ecto.Adapters.Neo4j.Storage.Migrator.lock_for_migrations/4."},{"ref":"Ecto.Adapters.Neo4j.html#prepare/2","title":"Ecto.Adapters.Neo4j.prepare/2","type":"function","doc":"Commands invoked to prepare a query for all, update_all and delete_all. The returned result is given to execute/6. Callback implementation for Ecto.Adapter.Queryable.prepare/2."},{"ref":"Ecto.Adapters.Neo4j.html#query/3","title":"Ecto.Adapters.Neo4j.query/3","type":"function","doc":"Execute given query on the databsse. This will return a Bolt.Sips.Response. Example iex&gt; cql = &quot;RETURN {num} AS n&quot; iex&gt; params = %{num: 5} ...&gt; {:ok, ...&gt; %Bolt.Sips.Response{ ...&gt; bookmark: _, ...&gt; fields: [&quot;n&quot;], ...&gt; notifications: [], ...&gt; plan: nil, ...&gt; profile: nil, ...&gt; records: [[5]], ...&gt; results: [%{&quot;n&quot; =&gt; 5}], ...&gt; stats: [], ...&gt; type: &quot;r&quot; ...&gt; }} = Ecto.Adapters.Neo4j.query(cql, params) iex&gt; :ok :ok"},{"ref":"Ecto.Adapters.Neo4j.html#query!/3","title":"Ecto.Adapters.Neo4j.query!/3","type":"function","doc":"Same as query/3 but raises in case of error."},{"ref":"Ecto.Adapters.Neo4j.html#rollback/2","title":"Ecto.Adapters.Neo4j.rollback/2","type":"function","doc":"Rolls back the current transaction. The transaction will return the value given as {:error, value}. See Ecto.Repo.rollback/1. Callback implementation for Ecto.Adapter.Transaction.rollback/2."},{"ref":"Ecto.Adapters.Neo4j.html#storage_down/1","title":"Ecto.Adapters.Neo4j.storage_down/1","type":"function","doc":"Drops the storage given by options. Returns :ok if it was dropped successfully. Returns {:error, :already_down} if the storage has already been dropped or {:error, term} in case anything else goes wrong. Examples storage_down(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_down/1."},{"ref":"Ecto.Adapters.Neo4j.html#storage_up/1","title":"Ecto.Adapters.Neo4j.storage_up/1","type":"function","doc":"Creates the storage given by options. Returns :ok if it was created successfully. Returns {:error, :already_up} if the storage has already been created or {:error, term} in case anything else goes wrong. Examples storage_up(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_up/1."},{"ref":"Ecto.Adapters.Neo4j.html#stream/5","title":"Ecto.Adapters.Neo4j.stream/5","type":"function","doc":"Streams a previously prepared query. It returns a stream of values. The adapter_meta field is a map containing some of the fields found in the Ecto.Query struct. Callback implementation for Ecto.Adapter.Queryable.stream/5."},{"ref":"Ecto.Adapters.Neo4j.html#supports_ddl_transaction?/0","title":"Ecto.Adapters.Neo4j.supports_ddl_transaction?/0","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.html#transaction/3","title":"Ecto.Adapters.Neo4j.transaction/3","type":"function","doc":"Runs the given function inside a transaction. Returns {:ok, value} if the transaction was successful where value is the value return by the function or {:error, value} if the transaction was rolled back where value is the value given to rollback/1. Callback implementation for Ecto.Adapter.Transaction.transaction/3."},{"ref":"Ecto.Adapters.Neo4j.html#update/6","title":"Ecto.Adapters.Neo4j.update/6","type":"function","doc":"Updates a single struct with the given filters. While filters can be any record column, it is expected that at least the primary key (or any other key that uniquely identifies an existing record) be given as a filter. Therefore, in case there is no record matching the given filters, {:error, :stale} is returned. Callback implementation for Ecto.Adapter.Schema.update/6."},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#batch_query/4","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.batch_query/4","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#batch_query!/4","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.batch_query!/4","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#checkout/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.checkout/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#execute/6","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.execute/6","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#get_conn/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.get_conn/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#in_transaction?/1","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.in_transaction?/1","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#prepare/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.prepare/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#query/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.query/3","type":"function","doc":"Launch the given query with params on database. Returns all found results, on raise a Bolt.Sips.Exception in case of error. As database errors should not be silently ignored, a wrong query will crash. Example Ecto.Adapters.Neo4j.Repo.query(&quot;MATCH (n:Post {uuid: {uuid}}&quot;, %{uuid: &quot;unique_id&quot;})"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#query!/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.query!/3","type":"function","doc":"Same as query but raises in case of error;"},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#rollback/2","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.rollback/2","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#stream/6","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.stream/6","type":"function","doc":"Not implemented yet."},{"ref":"Ecto.Adapters.Neo4j.Behaviour.Queryable.html#transaction/3","title":"Ecto.Adapters.Neo4j.Behaviour.Queryable.transaction/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html","title":"Ecto.Adapters.Neo4j.Cql.Node","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#build_query/9","title":"Ecto.Adapters.Neo4j.Cql.Node.build_query/9","type":"function","doc":"Builds a cypher query for given node_label, where, return parts. Example # with default `where` and `return` iex&gt; Ecto.Adapters.Neo4j.Cql.Node.build_query(:match, &quot;Post&quot;) &quot;MATCH (n:Post)\\n\\n\\n\\n RETURN n\\n\\n\\n &quot; # with everything defined iex&gt; node_label = &quot;Post&quot; iex&gt; where = &quot;title = {title}&quot; iex&gt; return = &quot;n&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.build_query(:match, node_label, where, &quot;&quot;, return) &quot;MATCH (n:Post) WHERE title = {title}\\n\\n\\n\\n RETURN n\\n\\n\\n &quot; # for deleting iex&gt; Ecto.Adapters.Neo4j.Cql.Node.build_query(:delete, &quot;Post&quot;) &quot;MATCH (n:Post)\\n\\n\\n DETACH DELETE n\\n RETURN n\\n\\n\\n &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_constraint/2","type":"function","doc":"Handle creation of unique constraints. Note that uniqueness on multiple properties is only available in Enterprise Edition Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint(&quot;Post&quot;, [:title]) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT n.title IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint(&quot;Post&quot;, [:title, :author]) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT (n.title, n.author) IS NODE KEY&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_constraint_index_from_cql/1","title":"Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql/1","type":"function","doc":"Builds a cypher for deleting a cosntraint or an index from the database. Required a constraint cql similar to the one provided by CALL db.constraints() Example iex&gt; constraint_cql = &quot;CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql(constraint_cql) &quot;CREATE CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; index_cql = &quot;INDEX ON :posts(nodeId)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_constraint_index_from_cql(index_cql) &quot;CREATE INDEX ON :posts(nodeId)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_index/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_index/2","type":"function","doc":"Handle creation of non unique indexes. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_index(&quot;Post&quot;, [:title]) &quot;CREATE INDEX ON :Post(title)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_index(&quot;Post&quot;, [:title, :author]) &quot;CREATE INDEX ON :Post(title, author)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#create_non_null_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.create_non_null_constraint/2","type":"function","doc":"Handle creation of non null constraints. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.create_non_null_constraint(&quot;Post&quot;, :title) &quot;CREATE CONSTRAINT ON (n:Post) ASSERT exists(n.title)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete/2","title":"Ecto.Adapters.Neo4j.Cql.Node.delete/2","type":"function","doc":"Returns cypher query to delete a node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete(&quot;Post&quot;, %{uuid: &quot;a-valid-uuid&quot;}) {&quot;MATCH (n:Post) WHERE n.uuid = {uuid} DETACH DELETE n RETURN n &quot;, %{uuid: &quot;a-valid-uuid&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete_all/0","title":"Ecto.Adapters.Neo4j.Cql.Node.delete_all/0","type":"function","doc":"Returns cypher query to delete all database data. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete_all() &quot;MATCH (n) DETACH DELETE n &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#delete_nodes/1","title":"Ecto.Adapters.Neo4j.Cql.Node.delete_nodes/1","type":"function","doc":"Returns cypher query to delete all given nodes. This operation shoudl be performed as a btach for performance reason. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.delete_nodes(&quot;Post&quot;) &quot;MATCH (n:Post) WITH n AS n LIMIT {limit} DETACH DELETE n RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_constraint/2","type":"function","doc":"Handle deletion of unique constraints. Note that uniqueness on multiple properties is only available in Enterprise Edition Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint(&quot;Post&quot;, [:title]) &quot;DROP CONSTRAINT ON (n:Post) ASSERT n.title IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint(&quot;Post&quot;, [:title, :author]) &quot;DROP CONSTRAINT ON (n:Post) ASSERT (n.title, n.author) IS NODE KEY&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_constraint_index_from_cql/1","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql/1","type":"function","doc":"Builds a cypher for deleting a cosntraint or an index from the database. Required a constraint cql similar to the one provided by CALL db.constraints() Example iex&gt; constraint_cql = &quot;CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql(constraint_cql) &quot;DROP CONSTRAINT ON ( posts:posts ) ASSERT posts.uuid IS UNIQUE&quot; iex&gt; index_cql = &quot;INDEX ON :posts(nodeId)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_constraint_index_from_cql(index_cql) &quot;DROP INDEX ON :posts(nodeId)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_index/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_index/2","type":"function","doc":"Handle deletion of non unique indexes. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_index(&quot;Post&quot;, [:title]) &quot;DROP INDEX ON :Post(title)&quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_index(&quot;Post&quot;, [:title, :author]) &quot;DROP INDEX ON :Post(title, author)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#drop_non_null_constraint/2","title":"Ecto.Adapters.Neo4j.Cql.Node.drop_non_null_constraint/2","type":"function","doc":"Handle deletion of non null constraints. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.drop_non_null_constraint(&quot;Post&quot;, :title) &quot;DROP CONSTRAINT ON (n:Post) ASSERT exists(n.title)&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#get_by_uuid/1","title":"Ecto.Adapters.Neo4j.Cql.Node.get_by_uuid/1","type":"function","doc":"Returns Cypher query to get one node given its uuid Parameters node_label: The node label to search on Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.get_by_uuid(&quot;Post&quot;) &quot;MATCH\\n (n:Post)\\nWHERE\\n n.uuid = {uuid}\\nRETURN\\n n\\n&quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#insert/3","title":"Ecto.Adapters.Neo4j.Cql.Node.insert/3","type":"function","doc":"Returns cypher query and params to insert a new node. Example iex&gt; data = %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.insert(&quot;Post&quot;, data) {&quot;CREATE (n:Post) SET n.title = {title}, \\nn.uuid = {uuid}\\n RETURN n &quot;, %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;}} # With returning fields specified iex&gt; data = %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.insert(&quot;Post&quot;, data, [:uuid]) {&quot;CREATE (n:Post) SET n.title = {title}, \\nn.uuid = {uuid}\\n RETURN n.uuid AS uuid &quot;, %{title: &quot;New title&quot;, uuid: &quot;a-valid-uuid&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#list_all_constraints/2","title":"Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints/2","type":"function","doc":"Builds a cypher query for listing all the constraints for a specific node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints(&quot;Post&quot;) &quot;CALL db.constraints() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; \\nRETURN description &quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_constraints(&quot;Post&quot;, :title) &quot;CALL db.constraints() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; AND description CONTAINS &#39;.title&#39; RETURN description &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#list_all_indexes/2","title":"Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes/2","type":"function","doc":"Builds a cypher query for listing all the indexes for a specific node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes(&quot;Post&quot;) &quot;CALL db.indexes() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; \\nRETURN description &quot; iex&gt; Ecto.Adapters.Neo4j.Cql.Node.list_all_indexes(&quot;Post&quot;, :title) &quot;CALL db.indexes() YIELD description WHERE description CONTAINS \\&quot;:Post\\&quot; AND description CONTAINS &#39;title&#39; RETURN description &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#relabel/2","title":"Ecto.Adapters.Neo4j.Cql.Node.relabel/2","type":"function","doc":"Build a query to relabel a node. Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.relabel(&quot;Post&quot;, &quot;NewPost&quot;) &quot;MATCH (n:Post) WITH n AS n LIMIT {limit} SET n:NewPost REMOVE n:Post RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#rename_property/3","title":"Ecto.Adapters.Neo4j.Cql.Node.rename_property/3","type":"function","doc":"Bulds a query to rename a property Example iex&gt; Ecto.Adapters.Neo4j.Cql.Node.rename_property(&quot;Post&quot;, &quot;titttle&quot;, &quot;title&quot;) &quot;MATCH (n:Post) WITH n AS n SKIP {skip} LIMIT {limit} SET n.title = n.titttle REMOVE n.titttle RETURN COUNT(n) AS nb_touched_nodes &quot;"},{"ref":"Ecto.Adapters.Neo4j.Cql.Node.html#update/3","title":"Ecto.Adapters.Neo4j.Cql.Node.update/3","type":"function","doc":"Returns cypher query to update node data. Example iex&gt; data = %{title: &quot;New title&quot;} iex&gt; filters = %{id: 5} iex&gt; Ecto.Adapters.Neo4j.Cql.Node.update(&quot;Post&quot;, data, filters) {&quot;MATCH (n:Post) WHERE n.id = {f_id} SET n.title = {title} RETURN n &quot;, %{f_id: 5, title: &quot;New title&quot;}}"},{"ref":"Ecto.Adapters.Neo4j.Helper.html","title":"Ecto.Adapters.Neo4j.Helper","type":"module","doc":"Useful helpers"},{"ref":"Ecto.Adapters.Neo4j.Helper.html#manage_id/2","title":"Ecto.Adapters.Neo4j.Helper.manage_id/2","type":"function","doc":"Manage id transformation from and to database. As Neo4j uses a field name id to store its internal id, the Ecto.Schema defined field id is transformed into nodeI to avoid any problem. Examples iex&gt; to_db_data = %{id: 3, value: &quot;test&quot;} iex&gt; from_db_data = Ecto.Adapters.Neo4j.Helper.manage_id(to_db_data, :to_db) %{nodeId: 3, value: &quot;test&quot;} iex&gt; Ecto.Adapters.Neo4j.Helper.manage_id(from_db_data, :from_db) %{id: 3, value: &quot;test&quot;}"},{"ref":"Ecto.Adapters.Neo4j.Storage.html","title":"Ecto.Adapters.Neo4j.Storage","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.html#storage_down/1","title":"Ecto.Adapters.Neo4j.Storage.storage_down/1","type":"function","doc":"Drops the storage given by options. Returns :ok if it was dropped successfully. Returns {:error, :already_down} if the storage has already been dropped or {:error, term} in case anything else goes wrong. Examples storage_down(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_down/1."},{"ref":"Ecto.Adapters.Neo4j.Storage.html#storage_up/1","title":"Ecto.Adapters.Neo4j.Storage.storage_up/1","type":"function","doc":"Creates the storage given by options. Returns :ok if it was created successfully. Returns {:error, :already_up} if the storage has already been created or {:error, term} in case anything else goes wrong. Examples storage_up(username: postgres, database: &#39;ecto_test&#39;, hostname: &#39;localhost&#39;) Callback implementation for Ecto.Adapter.Storage.storage_up/1."},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html","title":"Ecto.Adapters.Neo4j.Storage.Migrator","type":"module","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html#execute_ddl/3","title":"Ecto.Adapters.Neo4j.Storage.Migrator.execute_ddl/3","type":"function","doc":""},{"ref":"Ecto.Adapters.Neo4j.Storage.Migrator.html#lock_for_migrations/4","title":"Ecto.Adapters.Neo4j.Storage.Migrator.lock_for_migrations/4","type":"function","doc":""},{"ref":"readme.html","title":"Ecto adapter for Neo4j graph database","type":"extras","doc":"Ecto adapter for Neo4j graph database Goal EctoNeo4j is designed to ease the use of Neo4j in elixir and provides an adapter for Ecto.It allows to works with schema and to use the classic Ecto.Repo functions. BUT, as Ecto.Schema is relational-database oriented and Neo4j is a graph database, there is some limitations: join, assoc, preload related features are not available in Neo4j because they don&#39;t make sense in graph model."},{"ref":"readme.html#installation","title":"Ecto adapter for Neo4j graph database - Installation","type":"extras","doc":"Add ecto and ecto_neo4j to your dependencies: def deps do [ {:ecto, &quot;~&gt; 3.2}, {:ecto_sql, &quot;~&gt; 3.2}, {:ecto_neo4j, &quot;~&gt; 0.5&quot;} ] end ecto_sql is required if you planned to use the migration features. Configuration Configuration is very similar to other adapters: # In your config/config.exs file config :my_app, ecto_repos: [MyApp.Repo] # In your env-specific config, define database config (see bolt_sips for more information): config :my_app, MyApp.Repo, hostname: &#39;localhost&#39;, basic_auth: [username: &quot;user&quot;, password: &quot;pass&quot;], port: 7687, pool_size: 5, max_overflow: 1 # In your application code defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Neo4j end Knwons limitations"},{"ref":"readme.html#ecto-is-designed-for-relational-database-but-neo4j-is-a-graph-database","title":"Ecto adapter for Neo4j graph database - Ecto is designed for relational database but Neo4j is a graph database","type":"extras","doc":"Then not all of Ecto features are available in EctoNeo4j, either because they don&#39;t have their counterparts in Cypher Neo4j or because they don&#39;t make sense in Neo4j.The main feature unavailable in EctoNeo4j are those related to joins: join, assoc, preload, foreign_key, etc.Because of this limitations, EctoNeo4j is useful for one-node or one-label operations."},{"ref":"readme.html#the-special-case-of-ids","title":"Ecto adapter for Neo4j graph database - The special case of ids","type":"extras","doc":"As you may know, it is strongly recommended to NOT rely on Neo4j internal ids, as they can be reaffected.With Ecto.Schema, id can be managed automatically. EctoNeo4j allows to not change this way of working by using a property called nodeId on created/updated nodes. This proprety is automically converted into id when retrieving data from database. Usage"},{"ref":"readme.html#schema","title":"Ecto adapter for Neo4j graph database - Schema","type":"extras","doc":"Every schema fetaurees can be used as usual but keep in mind that all those related to joins will be irrelevant, this includes: has_many, has_one, belongs_to, many_to_many.prefix is not available as there is no counterpart in Neo4j (yet, but maybe in version 4 with the multiple databases)."},{"ref":"readme.html#migration","title":"Ecto adapter for Neo4j graph database - Migration","type":"extras","doc":"All features work, but with some subtleties for some.One important thing if you have big graph, all operations in migation are performed via batch. This means your migrations will also be complete, but it can take some time. More on batch here. What you need to know about migrations: create table don&#39;t do anything as expected as Neo4j is schemaless drop table will remove all the specified nodes and all existing indexes / constraints primary_key will be transformed in a constraint CONSTRAINT ON(n:label) ASSERT n.property IS UNIQUE create index(label, properties, unique: true) will either create an unique constraint or a node key constraint (which is only supported by Entreprise Edition) create index(label, properties) will create a classic index rename table and rename col will move the exisiting constraints and indexes from the old to the new entity"},{"ref":"readme.html#do-not-add-a-name-to-indexes-constraints","title":"Ecto adapter for Neo4j graph database - DO NOT ADD A NAME TO INDEXES / CONSTRAINTS","type":"extras","doc":"You have the possibility to give an index/constraint a name via the option of create/3. Don&#39;t do it.First, Neo4j doesn&#39;t support named indexes/cosntraints. Because of this &quot;limitation&quot;,in case of uniqueness error or such, EctoNeo4j has to rebuild an index name, which it does considering the default index naming."},{"ref":"readme.html#repo","title":"Ecto adapter for Neo4j graph database - Repo","type":"extras","doc":"Most of Ecto.Repo features work then you are free to use the classic Repo.insert, Repo.one, Repo.transaction etc. Unsupported features Repo.stream (maybe soon) nested transaction: they don&#39;t exists in Neo4j Repo.checkout About Ecto.Query As you expect, none all Ecto.Query are available, here is a list of whan can be used: distinct dynamic first from which is MATCH in cypher last limit offset order_by select which is RETURN in cypher update which is MATCH... SET in cypher where For very specific operation like CONTAINS, START_WITH, etc. I encourage you to use query fragment About update_all and delete_all Because theses two operations can touch a large number of nodes, you can have them be performed as batch via the option [batch: true].More on batch here."},{"ref":"readme.html#raw-cypher-query","title":"Ecto adapter for Neo4j graph database - Raw cypher query","type":"extras","doc":"Raw cypher queries can be executed thanks to Ecto.Adapters.Neo4j.query(cql, params, opts) and Ecto.Adapters.Neo4j.query!(cql, params, opts).They return a Bolt.Sips.Response if case of success Example: iex&gt; my_query = &quot;RETURN {num} AS num&quot; iex&gt; Ecto.Adapters.Neo4j.query(my_query, %{num: 5}) {:ok, %Bolt.Sips.Response{ bookmark: nil, fields: [&quot;num&quot;], notifications: [], plan: nil, profile: nil, records: [[5]], results: [%{&quot;num&quot; =&gt; 5}], stats: [], type: &quot;r&quot; }}"},{"ref":"readme.html#batch","title":"Ecto adapter for Neo4j graph database - Batch","type":"extras","doc":"Some updates or deletes can touch a large number of node and therefore required to be executed as batch in order to perform well (and to finish...).EctoNeo4j provides utility functions for this purpose: Ecto.Adapters.Neo4j.batch_query(cql, params, batch_type, opts) and Ecto.Adapters.Neo4j.batch_query!(cql, params, batch_type, opts).There is two types of batches and each require a specially formed query.They works on the same logic: execute a query count the touched nodes if the number of touched nodes is not 0 then back to 1 Batch types :basic The default batch type is :basic. Query must have: LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes This batch type is usually used for delete operation. It is not required to provide the limit in your params, it will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- THe WITH allows to work on a subset... n AS n &lt;--- LIMIT {limit} &lt;--- with the specified nuber of node DETACH DELETE &lt;--- Perform the desired operation n RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the numbere of node touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql) :with_skip This batch type is useful where a simple COUNT is irrevelant (in update operation for example). Query must have: SKIP {skip} LIMIT {limit} in order to specify the chunk size returns RETURN COUNT(the_node_you_re_touching) AS nb_touched_nodes in order to have the count of touched nodes It is not required to provide the skip nor the limit in your params, it will be handled by batch_query. Example: cql = &quot;&quot;&quot; MATCH (n:Post) WHERE n.title CONTAINS &quot;this&quot; WITH &lt;--- THe WITH allows to work on a subset... n AS n &lt;--- SKIP {skip} LIMIT {limit} &lt;--- with the specified nuber of node SET &lt;--- Perform the desired operation n.title = &quot;Updated: &quot; + n.title RETURN COUNT(n) AS nb_touched_nodes &lt;--- And return the numbere of node touched by the operation &quot;&quot;&quot; Ecto.Adapters.Neo4j.batch_query(cql, %{}, :with_skip) Chunk size The default chunk size is 10_000.The ideal chunk size is tighly related to the machine RAM, and you can specify if you want: at query level with the options [chunk_size: integer] Example: Ecto.Adapters.Neo4j.query(cql, params, :basic, [chunk_size: 50_000]) in your configuration, you can define the desired default chunk_size: config :ecto_neo4j, Ecto.Adapters.Neo4j, chunk_size: 50_000 update_all, delete_all You can have Repo.update_all and Repo.delete_all executed as batches with the option [batch: true] (without any query tricks).This option can be added in your configuration if you want the behaviour to happen for all update_alls and delete_alls. config :ecto_neo4j, Ecto.Adapters.Neo4j, batch: true TODO [x] Manage bolt role[ ] Split test to allow bolt v1 testing[ ] Support prefix? (is there any use case for this?)[ ] Support optimistic locking?[x] Support migration (only: index creation, drop, rename, alter column name)[x] Migration is supposed to support large amount of data (use batch...)[ ] Support insert select?[ ] Support delete with returning?[ ] Support map update?[ ] Implement a merge?[ ] Telemetry[ ] insert_all performance [ ] stream [ ] ecto.drop should remove constraints and indexes() Can I contribute? Yes, you can! Please, do!Just fork, commit and submit pull requests!"}]